require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ASM_H_)) {
    eval 'sub _MACHINE_ASM_H_ () {1;}' unless defined(&_MACHINE_ASM_H_);
    if(defined(&__PIC__)) {
	eval 'sub PIC_PROLOGUE () { &pushl % &ebx;  &call 666 &f; 666:  &popl % &ebx;  &addl $ &_C_LABEL( &_GLOBAL_OFFSET_TABLE_)+[.-666 &b], % &ebx;}' unless defined(&PIC_PROLOGUE);
	eval 'sub PIC_EPILOGUE () { &popl % &ebx;}' unless defined(&PIC_EPILOGUE);
	eval 'sub PIC_PLT {
	    my($x) = @_;
    	    eval q($x@ &PLT);
	}' unless defined(&PIC_PLT);
	eval 'sub PIC_GOT {
	    my($x) = @_;
    	    eval q($x@ &GOT(% &ebx));
	}' unless defined(&PIC_GOT);
	eval 'sub PIC_GOTOFF {
	    my($x) = @_;
    	    eval q($x@ &GOTOFF(% &ebx));
	}' unless defined(&PIC_GOTOFF);
    } else {
	eval 'sub PIC_PROLOGUE () {1;}' unless defined(&PIC_PROLOGUE);
	eval 'sub PIC_EPILOGUE () {1;}' unless defined(&PIC_EPILOGUE);
	eval 'sub PIC_PLT {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_PLT);
	eval 'sub PIC_GOT {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_GOT);
	eval 'sub PIC_GOTOFF {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_GOTOFF);
    }
    eval 'sub _C_LABEL {
        my($name) = @_;
	    eval q($name);
    }' unless defined(&_C_LABEL);
    eval 'sub _ASM_LABEL {
        my($x) = @_;
	    eval q($x);
    }' unless defined(&_ASM_LABEL);
    eval 'sub CVAROFF {
        my($x, $y) = @_;
	    eval q( &_C_LABEL($x) + $y);
    }' unless defined(&CVAROFF);
    if(defined(&__STDC__)) {
	eval 'sub __CONCAT {
	    my($x,$y) = @_;
    	    eval q($x  $y);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&__STRING);
    } else {
	eval 'sub __CONCAT {
	    my($x,$y) = @_;
    	    eval q($x $y);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    my($x) = @_;
    	    eval q(\\"x\\");
	}' unless defined(&__STRING);
    }
    eval 'sub STRONG_ALIAS {
        my($alias,$sym) = @_;
	    eval q(. &global $alias; $alias = $sym);
    }' unless defined(&STRONG_ALIAS);
    eval 'sub WEAK_ALIAS {
        my($alias,$sym) = @_;
	    eval q(. &weak $alias; $alias = $sym);
    }' unless defined(&WEAK_ALIAS);
    eval 'sub WARN_REFERENCES {
        my($_sym,$_msg) = @_;
	    eval q(. &section . ($gnu->{warning}).  $_sym ; . &ascii $_msg ; . &text);
    }' unless defined(&WARN_REFERENCES);
    unless(defined(&_ALIGN_TEXT)) {
	eval 'sub _ALIGN_TEXT () {. &align 2, 0x90;}' unless defined(&_ALIGN_TEXT);
    }
    eval 'sub _ENTRY {
        my($x) = @_;
	    eval q(. &text;  &_ALIGN_TEXT; . &globl $x; . &type $x,@ &function; $x:);
    }' unless defined(&_ENTRY);
    if(defined(&PROF) || defined(&GPROF)) {
	eval 'sub _PROF_PROLOGUE () { &pushl % &ebp;  &movl % &esp,% &ebp;  &call  &PIC_PLT( &mcount);  &popl % &ebp;}' unless defined(&_PROF_PROLOGUE);
    } else {
	eval 'sub _PROF_PROLOGUE () {1;}' unless defined(&_PROF_PROLOGUE);
    }
    eval 'sub ENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_C_LABEL($y));  &_PROF_PROLOGUE);
    }' unless defined(&ENTRY);
    eval 'sub NENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_C_LABEL($y)));
    }' unless defined(&NENTRY);
    eval 'sub ASENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($y));  &_PROF_PROLOGUE);
    }' unless defined(&ASENTRY);
    eval 'sub NASENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($y)));
    }' unless defined(&NASENTRY);
    eval 'sub END {
        my($y) = @_;
	    eval q(. &size $y, . - $y);
    }' unless defined(&END);
    eval 'sub ALTENTRY {
        my($name) = @_;
	    eval q(. &globl  &_C_LABEL($name);  &_C_LABEL($name):);
    }' unless defined(&ALTENTRY);
    eval 'sub ASMSTR () {. &asciz;}' unless defined(&ASMSTR);
    eval 'sub RCSID {
        my($x) = @_;
	    eval q(. &text; . &asciz $x);
    }' unless defined(&RCSID);
    if(defined(&_KERNEL)) {
	if(defined(&MULTIPROCESSOR)) {
	    eval 'sub CPUVAR {
	        my($var) = @_;
    		eval q(% &fs: &__CONCAT( &CPU_INFO_,$var));
	    }' unless defined(&CPUVAR);
	} else {
	    eval 'sub CPUVAR {
	        my($var) = @_;
    		eval q( &_C_LABEL( &cpu_info_primary)+ &__CONCAT( &CPU_INFO_,$var));
	    }' unless defined(&CPUVAR);
	}
    }
}
1;
