require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_INTR_H_)) {
    eval 'sub _MACHINE_INTR_H_ () {1;}' unless defined(&_MACHINE_INTR_H_);
    require 'machine/intrdefs.ph';
    unless(defined(&_LOCORE)) {
	require 'sys/mutex.ph';
	require 'machine/cpu.ph';
	eval 'sub IMASK {
	    my($level) = @_;
    	    eval q( $imask[ &IPL($level)]);
	}' unless defined(&IMASK);
	eval 'sub IUNMASK {
	    my($level) = @_;
    	    eval q( $iunmask[ &IPL($level)]);
	}' unless defined(&IUNMASK);
	eval 'sub __splbarrier () {
	    eval q( &__asm  &volatile(\\"\\":::\\"memory\\"));
	}' unless defined(&__splbarrier);
	if(defined(&DIAGNOSTIC)) {
	    eval 'sub splassert {
	        my($__wantipl) = @_;
    		eval q( &do {  &if ( &splassert_ctl > 0) {  &splassert_check($__wantipl,  &__func__); } }  &while (0));
	    }' unless defined(&splassert);
	    eval 'sub splsoftassert {
	        my($wantipl) = @_;
    		eval q( &splassert($wantipl));
	    }' unless defined(&splsoftassert);
	} else {
	    eval 'sub splassert {
	        my($wantipl) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&splassert);
	    eval 'sub splsoftassert {
	        my($wantipl) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&splsoftassert);
	}
	eval 'sub _SPLRAISE {
	    my($ocpl, $ncpl) = @_;
    	    eval q($ocpl =  &lapic_tpr;  &if ($ncpl > $ocpl)  &lapic_tpr = $ncpl);
	}' unless defined(&_SPLRAISE);
	eval 'sub _SPLX {
	    my($ncpl) = @_;
    	    eval q( &lapic_tpr = $ncpl;  &if ( &curcpu()-> &ci_ipending &  &IUNMASK($ncpl))  &Xspllower());
	}' unless defined(&_SPLX);
	eval 'sub splbio () {
	    eval q( &splraise( &IPL_BIO));
	}' unless defined(&splbio);
	eval 'sub splnet () {
	    eval q( &splraise( &IPL_NET));
	}' unless defined(&splnet);
	eval 'sub spltty () {
	    eval q( &splraise( &IPL_TTY));
	}' unless defined(&spltty);
	eval 'sub splaudio () {
	    eval q( &splraise( &IPL_AUDIO));
	}' unless defined(&splaudio);
	eval 'sub splclock () {
	    eval q( &splraise( &IPL_CLOCK));
	}' unless defined(&splclock);
	eval 'sub splstatclock () {
	    eval q( &splclock());
	}' unless defined(&splstatclock);
	eval 'sub splipi () {
	    eval q( &splraise( &IPL_IPI));
	}' unless defined(&splipi);
	eval 'sub splsoftclock () {
	    eval q( &splraise( &IPL_SOFTCLOCK));
	}' unless defined(&splsoftclock);
	eval 'sub splsoftnet () {
	    eval q( &splraise( &IPL_SOFTNET));
	}' unless defined(&splsoftnet);
	eval 'sub splsofttty () {
	    eval q( &splraise( &IPL_SOFTTTY));
	}' unless defined(&splsofttty);
	eval 'sub splvm () {
	    eval q( &splraise( &IPL_VM));
	}' unless defined(&splvm);
	eval 'sub splhigh () {
	    eval q( &splraise( &IPL_HIGH));
	}' unless defined(&splhigh);
	eval 'sub splsched () {
	    eval q( &splraise( &IPL_SCHED));
	}' unless defined(&splsched);
	eval 'sub spllock () {
	    eval q( &splhigh());
	}' unless defined(&spllock);
	eval 'sub spl0 () {
	    eval q( &spllower( &IPL_NONE));
	}' unless defined(&spl0);
	require 'machine/pic.ph';
	if(defined(&MULTIPROCESSOR)) {
	}
    }
    eval 'sub I386_SOFTINTR_SOFTCLOCK () {0;}' unless defined(&I386_SOFTINTR_SOFTCLOCK);
    eval 'sub I386_SOFTINTR_SOFTNET () {1;}' unless defined(&I386_SOFTINTR_SOFTNET);
    eval 'sub I386_SOFTINTR_SOFTTTY () {2;}' unless defined(&I386_SOFTINTR_SOFTTTY);
    eval 'sub I386_NSOFTINTR () {3;}' unless defined(&I386_NSOFTINTR);
    unless(defined(&_LOCORE)) {
	require 'sys/queue.ph';
	eval 'sub softintr_schedule {
	    my($arg) = @_;
    	    eval q( &do { \'struct i386_soft_intrhand\' * &__sih = ($arg); \'struct i386_soft_intr\' * &__si =  ($__sih->{sih_intrhead});  &mtx_enter(& ($__si->{softintr_lock}));  &if ( ($__sih->{sih_pending}) == 0) {  &TAILQ_INSERT_TAIL(& ($__si->{softintr_q}),  &__sih,  &sih_q);  ($__sih->{sih_pending}) = 1;  &softintr( ($__si->{softintr_ssir})); }  &mtx_leave(& ($__si->{softintr_lock})); }  &while ( 0));
	}' unless defined(&softintr_schedule);
    }
}
1;
